import machine
import neopixel
import mcp

np = neopixel.NeoPixel(machine.Pin(4), 150, timing=True)

mp = mcp.MCP(np=np)

import time   # time.sleep_ms() und time.ticks_ms()



# Hack to get ticks_ms() method in Tigerjython working
if not hasattr(time, 'ticks_ms'):
    from types import MethodType
    def ticks_ms(self):
        return int(round(self.time() * 1000))
    time.ticks_ms = MethodType(ticks_ms, time)
    
    def sleep_ms(self,a):
        time.sleep(a/1000.0)
    time.sleep_ms = MethodType(sleep_ms, time)
# END of Hack


i=0;

mask = 0
while True:
    np[i] = (250,20,50)
    np[(i+149)%150] = (0,0,0)
    np.write()
    i=(i+1)%150
    mask = mask ^ mp.getButtons();
    mp.setLeds(mask)
    time.sleep_ms(100)
